Foreman - Bug #14166

empty facet attributes not handled - "Creating a 'new host' fails for lifecycle_env and content_view
saying "can't be blank"

03/11/2016 04:49 PM - Partha Aji

Status: Closed
Priority: Normal
Assignee: Partha Aji
Category: Host creation
Target version: 1.11.1
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1313431 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3309
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1313431
Description of problem:

Creating a 'new host' fails for lifecycle_env and content_view saying "can't be blank", even though these values were set.

Version-Release number of selected component (if applicable):
Sat6.2.0-Beta-SNAP1

How reproducible:

Steps to Reproduce:

1. Create a "new host"

2. Provide "life-cycle env" and "content-view" values and also all the other needed values.
3. Click submit button.

Actual results:
To get a message "can't be blank" for "lifecycle-env" and "content-view".

Expected results:
"New host" page submission should be successful.
Additional info:

workaround: Again provide the values of "lifecycle-env" and "content-view".

Associated revisions

Revision 5d64eef2 - 03/28/2016 11:03 AM - Partha Aji
Fixes #14166 - Host facet attributes handling updated

Basically added code to include handling of host facets in hosts where
no form attributes belonging to that facet are set.

Revision c6b76367 - 04/18/2016 01:45 PM - Partha Aji
Fixes #14166 - Host facet attributes handling updated

Basically added code to include handling of host facets in hosts where
no form attributes belonging to that facet are set.

(cherry picked from commit 5d64eef2cba8e56ad39510c3bd1d724bd52762eb)

History

#1 - 03/11/2016 04:54 PM - Partha Aji

- Project changed from Katello to Foreman
https://bugzilla.redhat.com/show_bug.cgi?id=1313431

- Category deleted (Hosts)

#2 - 03/11/2016 05:19 PM - Partha Aji

- Subject changed from Creating a 'new host' fails for lifecycle_env and content_view saying "can't be blank" to empty facet attributes not handled -

"Creating a 'new host' fails for lifecycle_env and content_view saying "can't be blank"

The title is more of a symptom, but the root cause for this bug is this line in the upstream foreman.
https://github.com/theforeman/foreman/blob/develop/app/models/concerns/facets/managed _host_extensions.ro#L.39

def register_facet_relation(klass, facet_config)
klass.class_eval do
has_one facet_config.name, :class_name => facet_config.model.name, :foreign_key => :host_id,
e_of => :host
accepts_nested_attributes_for facet_config.name, :update_only => true

Basically accepts_nested_attributes_for usage does not provide an easy way to include in a form without sending blank attributes

#3 - 03/11/2016 05:24 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3309 added

#4 - 03/28/2016 12:01 PM - Partha Aji
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 5d64eef2cba8e56ad39510c3bd1d724bd52762eb.

#5 - 03/29/2016 04:06 AM - Dominic Cleal
- Category set to Host creation

- translation missing: en.field_release set to 141

#6 - 04/19/2016 03:33 AM - Dominic Cleal
- Has duplicate Bug #14696: Unable to create new host added

#7 - 04/20/2016 10:55 AM - Dominic Cleal
- Has duplicate deleted (Bug #14696: Unable to create new host)

#8 - 04/20/2016 10:55 AM - Dominic Cleal
- Related to Bug #14696: Unable to create new host added

#9 - 06/07/2016 07:38 AM - Anonymous
- Related to deleted (Bug #14696: Unable to create new host)
